## eztrace-contrib 2.1

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.7)
project(EZTrace
  VERSION 2.1.0
  LANGUAGES C
)


# include CMake modules
include(CheckLibraryExists)
include(CheckIncludeFiles)
include(CheckFunctionExists)
include(GNUInstallDirs)
include(CheckLanguage)
include(CheckCSourceCompiles)
include(CTest)

find_package(PkgConfig)

# POLICIES #####################
if (POLICY CMP0074)
  cmake_policy(SET CMP0074 NEW)
  cmake_policy(SET CMP0079 NEW)
endif()

# RPATH ########################################
set(CMAKE_MACOSX_RPATH 1)
set(CMAKE_SKIP_BUILD_RPATH FALSE) # use, i.e. don't skip the full RPATH for the build tree
set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) # when building, don't use the install RPATH already (but later on when installing)
set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_FULL_LIBDIR}") # the RPATH to be used when installing
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# CMakeFind repository
list (APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake_modules)

find_package (OTF2 REQUIRED)
if (NOT OTF2_FOUND)
   message(FATAL_ERROR "libotf2 not found.")
endif()

SET(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -I${OTF2_INCLUDE_PATH}")
SET(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -I${OTF2_INCLUDE_PATH}")

SET(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -D_GNU_SOURCE")
SET(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -D_GNU_SOURCE")

# Check if fortran is available
check_language(Fortran)
if(CMAKE_Fortran_COMPILER)
  enable_language(Fortran)
else()
  message(STATUS "No Fortran support")
endif()

# Look for library

#find_package (OpenMP)

# Options to enable/disable modules

option(EZTRACE_ENABLE_MPI      "Enable MPI module"      OFF)
option(EZTRACE_ENABLE_CUDA     "Enable CUDA module"     OFF)
option(EZTRACE_ENABLE_STARPU   "Enable StarPU module"   OFF)
option(EZTRACE_ENABLE_OPENMP   "Enable OpenMP module"   OFF)
#option(EZTRACE_ENABLE_PAPI     "Enable PAPI module"     OFF)
option(EZTRACE_ENABLE_POSIXIO  "Enable POSIXIO module"  ON)
option(EZTRACE_ENABLE_PTHREAD  "Enable Pthread module"  ON)
option(EZTRACE_ENABLE_MEMORY   "Enable Memory module"   OFF)
option(EZTRACE_ENABLE_OMPT     "Enable OMPT module"     OFF)
option(EZTRACE_ENABLE_PNETCDF "Enable PNetCDF module" OFF)
option(EZTRACE_ENABLE_NETCDF "Enable NetCDF module" OFF)
option(EZTRACE_ENABLE_IOTRACER "Enable IOtracer module" OFF)
option(EZTRACE_ENABLE_COMPILER_INSTRUMENTATION "Enable compiler-based instrumentation" ON)

SET(MPI_MODULE_NAME "mpi" CACHE STRING "Name of the MPI module")


option(ENABLE_BIN_INSTRUMENTATION "Enable binary instrumentation" OFF)

if(EZTRACE_ENABLE_IOTRACER)
  find_path(IOTRACER_PATH "bcc_iotracer.py" REQUIRED)
endif()

if(ENABLE_BIN_INSTRUMENTATION)
  find_library(BFD NAMES bfd)
  if (NOT BFD)
    message(FATAL_ERROR "libbfd found. This library is required for binary instrumentation")
  endif()

  find_package (LibOpcodes)
  CHECK_LIBRARY_EXISTS(opcodes disassembler "" disassembler_exist)
  if (NOT disassembler_exist)
    message(FATAL_ERROR "libopcodes: disassembler not found. This library is required for binary instrumentation")
  endif()

  set(EZTRACE_BINARY_INSTRUMENTATION_FLAG -DENABLE_BINARY_INSTRUMENTATION)

endif()

set (HAVE_DEMANGLE 0)
check_library_exists(iberty cplus_demangle "" cplus_demangle_exist)
if (cplus_demangle_exist)
  find_path (DEMANGLE_INCLUDEDIR NAMES "demangle.h"
    HINTS /usr/include/libiberty/
    )
  if(DEMANGLE_INCLUDEDIR)
    set (HAVE_DEMANGLE 1)
  else()
    message(WARNING " demangle.h not found. C++ symbols will not be demangled")
  endif()
else()
  message(WARNING " libiberty not found. C++ symbols will not be demangled")
endif()

if (EZTRACE_ENABLE_MPI)
  find_program(MPICC mpicc REQUIRED)
  find_program(MPIF90 mpif90)
endif()

if (EZTRACE_ENABLE_STARPU)
  find_package(STARPU "1.2" REQUIRED COMPONENTS HWLOC)
  list(APPEND CMAKE_INSTALL_RPATH ${STARPU_LIBRARY_DIRS})
endif()
 
# if (EZTRACE_ENABLE_PAPI)
#   find_package (LibPapi REQUIRED)
# endif()
# 
if (EZTRACE_ENABLE_CUDA)
  find_package (CUDA REQUIRED)
endif()

if (EZTRACE_ENABLE_OPENMP)
  find_package (OpenMP REQUIRED)
  find_program(OPARI2 opari2)
  find_program(OPARI2_CONFIG opari2-config)
  IF( NOT OPARI2)
    message(FATAL_ERROR " opari2 was not found. Please download it from https://www.vi-hps.org/projects/score-p#opari2 and install it")
  endIF(NOT OPARI2)
  IF (NOT OPARI2_CONFIG)
    message(FATAL_ERROR " opari2-config was not found. Please download it from https://www.vi-hps.org/projects/score-p#opari2 and install it")
  endIF (NOT OPARI2_CONFIG)
endif()

if (EZTRACE_ENABLE_PNETCDF)
   pkg_check_modules(pnetcdf REQUIRED pnetcdf)
endif()

if (EZTRACE_ENABLE_NETCDF)
   pkg_check_modules(netcdf REQUIRED netcdf)
endif()

if (EZTRACE_ENABLE_OMPT)
  find_package (OpenMP REQUIRED)
  find_package (OMPT REQUIRED)
endif()

#set(THREADS_PREFER_PTHREAD_GLAF ON)
#find_package(Threads REQUIRED)

####################################################
# Some flags for compilation

set (prefix "${CMAKE_INSTALL_PREFIX}")

check_include_files("sys/prctl.h" HAVE_PRCTL_H)
if (NOT HAVE_PRCTL_H)
  set(HAVE_PRCTL_H 0)
endif()

check_include_files("libbacktrace/backtrace.h" HAVE_LIBBACKTRACE)
if (NOT HAVE_LIBBACKTRACE)
  set(HAVE_LIBBACKTRACE 0)
endif()

set(LIBRARY_PATH "${CMAKE_INSTALL_PREFIX}/lib")
if ("${APPLE}")
  set(DYNLIB_EXT "dylib")
  set(LD_PRELOAD_NAME "DYLD_INSERT_LIBRARIES")
  set(LD_LIBRARY_PATH_NAME "DYLD_LIBRARY_PATH")
else() # By default -> Linux
  set(DYNLIB_EXT "so")
  set(LD_PRELOAD_NAME "LD_PRELOAD")
  set(LD_LIBRARY_PATH_NAME "LD_LIBRARY_PATH")
endif()

set(EZTRACE_LIB_DIR ${CMAKE_INSTALL_FULL_LIBDIR})
#set(PPTRACE_BINARY_TYPE "PPTRACE_BINARY_TYPE_BFD")
#set(__PPTRACE_BINARY_TYPE "PPTRACE_BINARY_TYPE_BFD")
#set(abs_top_builddir ${CMAKE_BINARY_DIR})

set(INSTALL_INCLUDEDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR}")
set(INSTALL_LIBDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
set(INSTALL_PKGCONFIG_DIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

# Subdirectory
add_subdirectory (src)


add_subdirectory (test/)

include(PrintOpts)

set(EZTRACE_MAN_PAGES ${CMAKE_CURRENT_SOURCE_DIR}/doc/man/)
install(DIRECTORY ${EZTRACE_MAN_PAGES} DESTINATION "${CMAKE_INSTALL_MANDIR}")

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/eztrace.pc.in
               ${CMAKE_CURRENT_BINARY_DIR}/eztrace.pc)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/eztrace.pc DESTINATION "${INSTALL_PKGCONFIG_DIR}")

message(STATUS "OTF2 version: ${OTF2_VERSION}")

=== test/CMakeLists.txt ===
enable_testing()

set(EZTRACE_LIBRARY_PATH "${CMAKE_BINARY_DIR}/src/eztrace-lib")
set(TEST_ENVIRONMENT  "EZTRACE_AVAIL_PATH=${CMAKE_BINARY_DIR}/src/eztrace_avail"
  "EZTRACE_CC_PATH=${CMAKE_BINARY_DIR}/src/modules/omp/bin/eztrace_cc"
  "EZTRACE_PATH=${CMAKE_BINARY_DIR}/src/eztrace"
  "OTF2_PRINT_PATH=${OTF2_PRINT}"
  "EZTRACE_TEST_OPTION=-p"
)


add_subdirectory (unit_tests)

if (EZTRACE_ENABLE_COMPILER_INSTRUMENTATION)
  add_subdirectory (compiler_instrumentation)
endif()

if (EZTRACE_ENABLE_MPI)
  add_subdirectory (mpi)
endif()

if (EZTRACE_ENABLE_MEMORY)
  add_subdirectory (memory)
endif()

if (EZTRACE_ENABLE_OPENMP)
  add_subdirectory (openmp)
endif()

if (EZTRACE_ENABLE_OMPT)
  add_subdirectory (ompt)
endif()

if (EZTRACE_ENABLE_PTHREAD)
  add_subdirectory (pthread)
endif()

if (EZTRACE_ENABLE_POSIXIO)
  add_subdirectory (posixio)
endif()

=== test/compiler_instrumentation/Makefile ===
CFLAGS=-finstrument-functions -O0
LDFLAGS=-rdynamic

BIN=foo

all: $(BIN)

%: %.c
	$(CC) -o $@ $^ $(CFLAGS) $(LDFLAGS) 

test: $(BIN)
	./run.sh
clean:
	rm -f $(BIN)

=== test/ompt/Makefile ===
CC=clang
CFLAGS=-fopenmp
LDFLAGS=-fopenmp

BIN=test_lock test_task test_parallel_for test_ompt

all: $(BIN)

clean:
	rm -f $(BIN)

=== test/posixio/CMakeLists.txt ===
enable_testing()

if (EZTRACE_ENABLE_POSIXIO)

  set(CMAKE_C_FLAGS "-pthread")
  set(LINK_OPTIONS  "-pthread")

  add_executable(posixio posixio.c)
  add_test(build_posixio "${CMAKE_COMMAND}" --build "${CMAKE_BINARY_DIR}" --target posixio)
  add_executable(my_cat my_cat.c)
  add_test(build_my_cat "${CMAKE_COMMAND}" --build "${CMAKE_BINARY_DIR}" --target my_cat)

  add_test (posixio_tests bash "${CMAKE_CURRENT_SOURCE_DIR}/run.sh" DEPENDS "build_posixio;build_my_cat")
  set(EZTRACE_LIBRARY_PATH "${EZTRACE_LIBRARY_PATH}:${CMAKE_BINARY_DIR}/src/modules/posixio")


  # Get the list of tests, and set environment variables
  get_property(test_list DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY TESTS)
  set_property(TEST ${test_list}
    PROPERTY ENVIRONMENT
    "EZTRACE_LIBRARY_PATH=${EZTRACE_LIBRARY_PATH}"
    ${TEST_ENVIRONMENT}
  )
endif()

=== src/modules/mpi/CMakeLists.txt ===
file(GLOB mpi_function_files mpi_funcs/*.c mpi_funcs/*.h)

set(eztrace-mpi_SOURCES
    ${mpi_function_files}
    mpi.c
    mpi_eztrace.h
    )

  # Compile this module with mpicc/mpif90
set(CMAKE_C_COMPILER ${MPICC})
set(CMAKE_Fortran_COMPILER ${MPIF90})

if(CMAKE_Fortran_COMPILER)
  # mpif.h may define a bunch of unused parameter which would generate lots of warnings
  set(eztrace-mpi_SOURCES ${eztrace-mpi_SOURCES}
    mpi3_f.f90  fortran_utils.f90  mpi_f.f90   mpi_fortran.c)
  
  set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -Wno-unused-parameter")
endif()


add_library(eztrace-mpi SHARED
  ${eztrace-mpi_SOURCES}
)

target_include_directories(eztrace-mpi
  PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/src/core/include/eztrace-core/
)

target_link_libraries(eztrace-mpi
  PRIVATE
    ${INTERCEPT_LIB}
    eztrace-core
    eztrace-lib
)

target_compile_options(eztrace-mpi
  PRIVATE
    -Wall -Wextra
    -DUSE_MPI3
    -DLD_PRELOAD_NAME=\"${LD_PRELOAD_NAME}\"
    -DMPI_MODULE_NAME=${MPI_MODULE_NAME}
    -Wno-error=incompatible-pointer-types       # TODO
    -Wno-error=pointer-arith                    # TODO
    -Wno-error=int-conversion                   # TODO
  )

set_target_properties(eztrace-mpi
  PROPERTIES
  OUTPUT_NAME eztrace-${MPI_MODULE_NAME}
  )
#----------------------------------------------------

install(TARGETS eztrace-mpi
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

=== debian/changelog ===
eztrace-contrib (2.1-1) unstable; urgency=medium

  * New upstream release (Closes: #968312)
    - control: Add libnetcdf-dev and libpnetcdf-dev dependencies.
    - patches/git-arm: Upstreamed.
    - patches/git-atomic: Upstreamed.
    - patches/git-eztpomp: Upstreamed.
    - patches/git-eztrace_cc_path: Upstreamed.
    - patches/git-eztrace_cc_x: Upstreamed.
    - patches/git-functions: Upstreamed.
    - patches/git-input: Upstreamed.
    - patches/git-libatomic: Upstreamed.
    - patches/git-manpage: Upstreamed.
    - patches/git-memory-noopt: Upstreamed.
    - patches/git-missing-tests: Upstreamed.
    - patches/git-mpi-init: Upstreamed.
    - patches/git-mpi-init-called: Upstreamed.
    - patches/git-mpi-types: Upstreamed.
    - patches/git-mpi_module_name: Upstreamed.
    - patches/git-no-install-cmake: Upstreamed.
    - patches/git-opari2: Upstreamed.
    - patches/git-openmp-nested-lock: Upstreamed.
    - patches/git-otf2: Upstreamed.
    - patches/git-otf2-3: Upstreamed.
    - patches/git-path_space: Upstreamed.
    - patches/git-pkg-config: Upstreamed.
    - patches/git-pkgconfig: Upstreamed.
    - patches/git-rename: Upstreamed.
    - patches/git-test-conditioned: Upstreamed.
    - patches/git-test-mpi-path: Upstreamed.
    - patches/git-test-openmp: Upstreamed.
    - patches/git-test-openmp2: Upstreamed.
    - patches/git-test-path: Upstreamed.
    - patches/git-test-paths: Upstreamed.
    - patches/git-test-preload-libs: Upstreamed.
    - patches/git-test-programs-path: Upstreamed.
    - patches/git-test-source: Upstreamed.
    - patches/git-test-verbose: Upstreamed.
    - patches/otf2-2.0.3: Upstreamed.
    - patches/starpu-1.3: Upstreamed.
    - patches/norpath: Refreshed.
    - patches/werror: Refreshed.
    - patches/git-starpu-1.4: Fix finding starpu-1.4.
    - patches/git-starpu-1.4-task_submit: Fix building against starpu 1.4.
    - patches/starpu-job: Drop some test for now.
    - patches/git-eztrace_avail: Fix finding eztrace_avail.
    - patches/git-self-link: Fix linking against libeztpomp.
    - patches/git-starpu-install: Actually install StarPU module.
    - libeztrace0.lintian-overrides: Update.
    - rules: Enable STARPU, NETCDF and PNETCDF (where applicable).
    - rules: Set STARPU_HOME to CURDIR.
    - rules: Update blhc ignore patterns.
    - tests/control: Enable compiler_instrumentation and starpu tests.
    - libeztrace0-contrib.install: Install only cuda plugin.

 -- Samuel Thibault <sthibault@debian.org>  Fri, 25 Aug 2023 15:03:30 +0200

eztrace-contrib (2.0+repack-12) unstable; urgency=medium

  * control: Add missing breaks+replaces between libeztrace0 and
    libeztrace-dev, missed when moving /usr/lib/*/*.so from the latter to the
    former (Closes: Bug#1034956)

 -- Samuel Thibault <sthibault@debian.org>  Thu, 27 Apr 2023 16:07:04 +0200

eztrace-contrib (2.0+repack-11) unstable; urgency=medium

  * control: Always depend on otf2, eztrace now always requires it actually.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 20 Dec 2022 16:17:31 +0100

eztrace-contrib (2.0+repack-10) unstable; urgency=medium

  * control: Fix arch exclusion.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 20 Dec 2022 13:25:22 +0100

eztrace-contrib (2.0+repack-9) unstable; urgency=medium

  * patches/otf2-2.0.3: Fix build with otf2 2.0.3.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 20 Dec 2022 13:12:31 +0100

eztrace-contrib (2.0+repack-8) unstable; urgency=medium

  * control: Make Multi-Arch: foreign.
  * control: Drop otf2 support on archs which don't have the atomics required
    by otf2.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 20 Dec 2022 12:59:58 +0100

eztrace-contrib (2.0+repack-7) unstable; urgency=medium

  * rules, tests/control: Pass --oversubscribe to openmpi to avoid failure on
    machines with only one processor.
  * rules: Make openmpi failure fatal again, now that pmix is fixed in
    unstable.
  * rules: Fix installing headers in multiarch path.

 -- Samuel Thibault <sthibault@debian.org>  Fri, 26 Aug 2022 14:11:50 +0200

eztrace-contrib (2.0+repack-6) unstable; urgency=medium

  * control: Only build-dep on clang when we'll build the ompt module.

 -- Samuel Thibault <sthibault@debian.org>  Thu, 25 Aug 2022 14:41:14 +0200

eztrace-contrib (2.0+repack-5) unstable; urgency=medium

  * patches/git-mpi-init-called: MPI: avoid multiple initialization.
  * patches/git-test-openmp2: Fix OpenMP tests build.
  * debian/rules: Can now use dh_auto_test again.
  * debian/rules: Reduce build time by only building&testing the targeted
    modules.
  * debian/rules: Update blhc ignore line.

 -- Samuel Thibault <sthibault@debian.org>  Thu, 25 Aug 2022 14:01:01 +0200

eztrace-contrib (2.0+repack-4) unstable; urgency=medium

  * patches/test-verbose: Use upstream commit.
  * patches/test-programs-path: Fix the path of test programs.
  * patches/test-preload-libs: Use upstream commit.
  * rules: Pass EZTRACE_TEST_OPTION=-p.
  * patches/*: Reflush patches in the upstream order.
  * patches/git-otf2: Include upstream otf2 detection fix.
  * rules: Make mpi fork-safe.
  * patches/git-test-source: Fix running test from source with make test.
  * rules: Print blhc false positive suppressions (Closes: Bug#101804)
  * patches/git-openmp-nested-lock: Fix nested locks.

 -- Samuel Thibault <sthibault@debian.org>  Thu, 25 Aug 2022 09:53:43 +0200

eztrace-contrib (2.0+repack-3) unstable; urgency=medium

  * rules: Actually run tests at package build time.
  * control: Add bw, gawk build-deps.
  * patches/test-preload-libs: Add just-built libeztrace-lib.so to LD_PRELOAD.
  * patches/memory-noopt: Disable optimizations to make sure calloc etc. are
    kept.
  * patches/test-verbose: Show the actual test output.
  * copyright: Fix catching pomp files.

 -- Samuel Thibault <sthibault@debian.org>  Wed, 24 Aug 2022 14:18:42 +0200

eztrace-contrib (2.0+repack-2) unstable; urgency=medium

  * debian/copyright: Fix copyright information for pomp-lib-dummy.


=== debian/control ===
Source: eztrace-contrib
Section: contrib/devel
Priority: optional
Maintainer: Samuel Thibault <sthibault@debian.org>
Build-Depends: debhelper-compat (= 12),
 pkg-config,
 cmake,
 bc, gawk,
 gfortran,
 libiberty-dev, binutils-dev (>= 2.29~), zlib1g-dev,
 nvidia-cuda-toolkit-gcc (>= 9~),
# gcc-7, g++-7,
# clang-5.0,
 libcupti-dev, python3, mesa-common-dev,
 libotf2-trace-dev, otf2-tools,
 opari2, libpomp2-dev,
 clang [amd64 arm64 i386 ppc64el riscv64], libomp-dev [amd64 arm64 i386 ppc64el riscv64],
 libstarpu-dev (>= 1.3~),
 libnetcdf-dev, libpnetcdf-dev [amd64 arm64 mips64el ppc64el s390x alpha ia64 sparc64 kfreebsd-amd64 ppc64 riscv64],
 libpapi-dev [amd64 arm64 armel armhf i386 mipsel powerpc ppc64el mips64el ppc64 x32],
 libmpich-dev, mpi-default-dev, mpi-default-bin
Rules-Requires-Root: no
Build-Conflicts: libeztrace0
Standards-Version: 4.6.0
Homepage: https://eztrace.gitlab.io/eztrace/
Vcs-Git: https://salsa.debian.org/debian/eztrace.git -b contrib
Vcs-Browser: https://salsa.debian.org/debian/eztrace/-/tree/contrib

Package: libeztrace0-contrib
Section: contrib/libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, libeztrace0
Pre-Depends: ${misc:Pre-Depends}
Description: Automatic execution trace generation for HPC - runtime libraries
 EZTrace is a tool that aims at generating automatically execution traces
 from HPC (High Performance Computing) programs. It generates execution
 trace files that can be interpreted by visualization tools such as
 ViTE. It uses LD_PRELOAD and dlsym() to intercept calls to the usual HPC
 primitives, to be observed.
 .
 This package contains the development files depending on CUDA.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk
include /usr/share/mpi-default-dev/debian_defaults

ifeq ($(ARCH_DEFAULT_MPI_IMPL),openmpi)
OPENMPI=yes
else
OPENMPI=no
endif

OMPT_ARCHS = amd64 arm64 i386 ppc64el riscv64

CONFIGURE_ENV=
CONFIGURE=-DCMAKE_INSTALL_INCLUDEDIR=/usr/include/$(DEB_HOST_MULTIARCH)

CONFIGURE_ENV+=CUPTI_ROOT=/usr
CONFIGURE+=-DEZTRACE_ENABLE_CUDA=ON

#export NVCCFLAGS = "-ccbin clang-5.0"
#export NVCCFLAGS = "-ccbin gcc-7"
export NVCCFLAGS = "--compiler-options -std=c++03 --compiler-options -D__GNUC__=7"

ifeq (,$(filter $(DEB_HOST_ARCH),amd64 arm64 mips64el ppc64el s390x alpha ia64 sparc64 kfreebsd-amd64 ppc64 riscv64))
CONFIGURE+=-DEZTRACE_ENABLE_PNETCDF=OFF
endif

%:
	dh $@

override_dh_auto_configure:
	$(CONFIGURE_ENV) dh_auto_configure -Bbuild-mpich -- $(CONFIGURE) \
		-DEZTRACE_ENABLE_CUDA=ON \
		-DEZTRACE_ENABLE_MPI=OFF \
		-DEZTRACE_ENABLE_STARPU=OFF \
		-DEZTRACE_ENABLE_OPENMP=OFF \
		-DEZTRACE_ENABLE_POSIXIO=OFF \
		-DEZTRACE_ENABLE_PTHREAD=OFF \
		-DEZTRACE_ENABLE_MEMORY=OFF \
		-DEZTRACE_ENABLE_OMPT=OFF \
		-DEZTRACE_ENABLE_PNETCDF=OFF \
		-DEZTRACE_ENABLE_NETCDF=OFF \
		-DEZTRACE_ENABLE_IOTRACER=OFF \
		$(CONFIGURE)

override_dh_auto_build:
	dh_auto_build -Bbuild-mpich -- -C src/modules/cuda

override_dh_auto_clean:
	dh_auto_clean -Bbuild-mpich -- -C src/modules/cuda

override_dh_auto_install:
	dh_auto_install --destdir=debian/tmp -Bbuild-mpich -- -C src/modules/cuda

override_dh_auto_test:
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?.*src/modules/omp/bin/eztrace_cc\ .*'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?\[eztrace_cc\].*'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?cc\ -o\ test_task.*'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?cc\ -o\ starpu_.*'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?cc\ -o\ .*\ -pthread'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?cc.*\ memory.c.*\ -o\ memory'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?cc\ -o\ foo\ foo.c.*'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?g\+\+\ -o\ vector\ vector.cxx'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?.*/cc\ .*\ -c\ .*/test/.*.c'
	-verbose=1 dh_auto_test --no-parallel -Bbuild-mpich -- -C src/modules/cuda -k ARGS\+=--extra-verbose

override_dh_dwz:
	:

## eztrace-contrib 2.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -60,6 +60,7 @@
 option(EZTRACE_ENABLE_MPI      "Enable MPI module"      OFF)
 option(EZTRACE_ENABLE_CUDA     "Enable CUDA module"     OFF)
 option(EZTRACE_ENABLE_STARPU   "Enable StarPU module"   OFF)
+option(EZTRACE_ENABLE_STARPU_API   "Enable StarPU module (using the StarPU profiling API)"   OFF)
 option(EZTRACE_ENABLE_OPENMP   "Enable OpenMP module"   OFF)
 #option(EZTRACE_ENABLE_PAPI     "Enable PAPI module"     OFF)
 option(EZTRACE_ENABLE_POSIXIO  "Enable POSIXIO module"  ON)
@@ -120,13 +121,19 @@
   find_package(STARPU "1.2" REQUIRED COMPONENTS HWLOC)
   list(APPEND CMAKE_INSTALL_RPATH ${STARPU_LIBRARY_DIRS})
 endif()
- 
+
+if (EZTRACE_ENABLE_STARPU_API)
+  find_package(STARPU "1.4" REQUIRED COMPONENTS HWLOC)
+  list(APPEND CMAKE_INSTALL_RPATH ${STARPU_LIBRARY_DIRS})
+endif()
+
 # if (EZTRACE_ENABLE_PAPI)
 #   find_package (LibPapi REQUIRED)
 # endif()
 # 
 if (EZTRACE_ENABLE_CUDA)
   find_package (CUDA REQUIRED)
+  find_package (CUDAToolkit REQUIRED)
 endif()
 
 if (EZTRACE_ENABLE_OPENMP)

=== test/mpi/CMakeLists.txt ===
enable_testing()

if (EZTRACE_ENABLE_MPI)
  set(CMAKE_C_COMPILER ${MPICC})
  set(CMAKE_Fortran_COMPILER ${MPIF90})

  add_executable(mpi_ping ../mpi/mpi_ping.c)
  add_test (build_mpi_ping "${CMAKE_COMMAND}" --build "${CMAKE_BINARY_DIR}" --target mpi_ping)

  add_executable(mpi_pthread ../mpi/mpi_pthread.c)
  add_test (build_mpi_pthread "${CMAKE_COMMAND}" --build "${CMAKE_BINARY_DIR}" --target mpi_pthread)

  add_test (mpi_tests bash "${CMAKE_CURRENT_SOURCE_DIR}/../mpi/run.sh" DEPENDS "build_mpi_ping build_mpi_pthread")
  set(EZTRACE_LIBRARY_PATH "${EZTRACE_LIBRARY_PATH}:${CMAKE_BINARY_DIR}/src/modules/mpi")

  # Get the list of tests, and set environment variables
  get_property(test_list DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY TESTS)
  set_property(TEST ${test_list}
    PROPERTY ENVIRONMENT
    "EZTRACE_LIBRARY_PATH=${EZTRACE_LIBRARY_PATH}"
    ${TEST_ENVIRONMENT}
  )
endif()

=== test/ompt/CMakeLists.txt ===
enable_testing()

if (EZTRACE_ENABLE_OMPT)
  set(CMAKE_C_FLAGS "-fopenmp")
  set(LINK_OPTIONS "-fopenmp")

  add_executable(ompt_test_lock test_lock.c)
  add_executable(ompt_test_parallel_for test_parallel_for.c)
  add_executable(ompt_test_task test_task.c)

  set_target_properties(ompt_test_lock PROPERTIES OUTPUT_NAME "test_lock")
  set_target_properties(ompt_test_parallel_for PROPERTIES OUTPUT_NAME "test_parallel_for")
  set_target_properties(ompt_test_task PROPERTIES OUTPUT_NAME "test_task")

  add_test(ompt_build_test_lock "${CMAKE_COMMAND}" --build "${CMAKE_BINARY_DIR}" --target ompt_test_lock)
  add_test(ompt_build_test_parallel_for "${CMAKE_COMMAND}" --build "${CMAKE_BINARY_DIR}" --target ompt_test_parallel_for)
  add_test(ompt_build_test_task "${CMAKE_COMMAND}" --build "${CMAKE_BINARY_DIR}" --target ompt_test_task)

  add_test (ompt_tests bash "${CMAKE_CURRENT_SOURCE_DIR}/run.sh" DEPENDS "ompt_build_test_lock;ompt_build_test_parallel_for;ompt_build_test_task")
  set(EZTRACE_LIBRARY_PATH "${EZTRACE_LIBRARY_PATH}:${CMAKE_BINARY_DIR}/src/modules/ompt")


  # Get the list of tests, and set environment variables
  get_property(test_list DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY TESTS)
  set_property(TEST ${test_list}
    PROPERTY ENVIRONMENT
    "EZTRACE_LIBRARY_PATH=${EZTRACE_LIBRARY_PATH}"
    ${TEST_ENVIRONMENT}
  )
endif()

=== test/pthread/CMakeLists.txt ===
enable_testing()

if (EZTRACE_ENABLE_PTHREAD)

  set(CMAKE_C_FLAGS "-pthread")
  set(LINK_OPTIONS  "-pthread")

  add_executable(dummy_thread dummy_thread.c)
  add_test(build_dummy_thread "${CMAKE_COMMAND}" --build "${CMAKE_BINARY_DIR}" --target dummy_thread)

  add_test (pthread_tests bash "${CMAKE_CURRENT_SOURCE_DIR}/run.sh" DEPENDS build_dummy_thread)
  set(EZTRACE_LIBRARY_PATH "${EZTRACE_LIBRARY_PATH}:${CMAKE_BINARY_DIR}/src/modules/pthread")


  # Get the list of tests, and set environment variables
  get_property(test_list DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY TESTS)
  set_property(TEST ${test_list}
    PROPERTY ENVIRONMENT
    "EZTRACE_LIBRARY_PATH=${EZTRACE_LIBRARY_PATH}"
    ${TEST_ENVIRONMENT}
  )
endif()

=== test/starpu/Makefile ===
CFLAGS=`pkg-config --cflags starpu-1.3`
LDFLAGS=`pkg-config --libs starpu-1.3`

BIN=starpu_hello starpu_mult

all: $(BIN)

%: %.c
	$(CC) -o $@ $^ $(CFLAGS) $(LDFLAGS)

test: $(BIN)
	./run.sh
clean:
	rm -f $(BIN)

=== doc/example/libexample_eztrace/Makefile ===
# Copyright (C) CNRS, INRIA, Université Bordeaux 1, Télécom SudParis
# See COPYING in top-level directory.

BIN = libeztrace-example.so

LDFLAGS=`pkg-config --libs eztrace`
CFLAGS=`pkg-config --cflags eztrace`

all: $(BIN)

libeztrace-example.so: example.c
	$(CC) --shared -o libeztrace-example.so example.c -fPIC $(CFLAGS) $(LDFLAGS) -ldl

clean:
	rm -f $(BIN)

=== src/modules/ompt/CMakeLists.txt ===
add_library(eztrace-ompt SHARED
  openmp.c
)

target_link_libraries(eztrace-ompt
  PRIVATE
    atomic
    dl
    eztrace-core
    eztrace-lib
    eztrace-instrumentation
    ${OMPT_LIBRARY}
    )

target_include_directories(eztrace-ompt
  PRIVATE
  ${CMAKE_SOURCE_DIR}/src/core/include/eztrace-core/
  ${OMPT_INCLUDE_DIR}
)

target_compile_options(eztrace-ompt
  PUBLIC
  -fopenmp
)

target_link_options(eztrace-ompt
  PUBLIC
  -fopenmp
)

#---------------------------------------------

install(TARGETS eztrace-ompt
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

=== src/modules/pthread/CMakeLists.txt ===
add_library(eztrace-pthread SHARED
  pthread.c
)

target_link_libraries(eztrace-pthread
  PRIVATE
    dl
    eztrace-core
    eztrace-lib
    eztrace-instrumentation
)

target_include_directories(eztrace-pthread
  PRIVATE
  ${CMAKE_SOURCE_DIR}/src/core/include/eztrace-core/
)

#---------------------------------------------

install(TARGETS eztrace-pthread
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

=== src/modules/starpu/CMakeLists.txt ===
# set(CMAKE_REQUIRED_INCLUDES "${STARPU_INCLUDE_DIRS}")
# foreach(libdir ${STARPU_LIBRARY_DIRS})
#   list(APPEND CMAKE_REQUIRED_FLAGS "-L${libdir}")
# endforeach()
# string(REPLACE ";" " " CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS}")
# set(CMAKE_REQUIRED_LIBRARIES "${STARPU_LIBRARIES}")

check_function_exists(starpu_mpi_data_register_comm STARPU_MPI_DATA_REGISTER_COMM_FOUND)
if ( STARPU_MPI_DATA_REGISTER_COMM_FOUND )
  add_definitions(-DHAVE_STARPU_MPI_DATA_REGISTER_COMM)
endif()


# Include directories
#include_directories(
#  ${MPI_INCLUDE_PATH}
#  )

# Libraries diretory
  # ${STARPU_LIBRARY_DIRS}

# Create : libeztrace-starpu.so
add_library(eztrace-starpu SHARED
  starpu.c
)

target_include_directories(eztrace-starpu
  PRIVATE
    ${STARPU_INCLUDE_DIRS}
)

target_link_libraries(eztrace-starpu
  PRIVATE
    dl
    eztrace-core
    eztrace-lib
    ${STARPU_LIBRARIES}
)

install(TARGETS eztrace-starpu
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

=== debian/changelog ===
eztrace-contrib (2.1.1-1) unstable; urgency=medium

  * New upstream release (Closes: Bug#1086265)
    - debian/patches/git-self-link: Upstreamed.
    - debian/patches/git-starpu-1.4: Upstreamed.
    - debian/patches/git-starpu-1.4-task_submit: Upstreamed.
    - debian/patches/git-eztrace_avail: Upstreamed.
    - debian/patches/git-starpu-install: Upstreamed.
    - debian/patches/implicit: Upstreamed.
  * debian/rules: Run all testsuites before reporting the failures
    (Closes: Bug#1067468)
  * debian/rules: Add mpi smoketest rules.
  * debian/control: Depend on pkgconf instead of pkg-config.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 10 Nov 2024 02:21:32 +0100

eztrace-contrib (2.1-7) unstable; urgency=medium

  * patches/implicit: Fix build with qa=+bug-implicit-func
    (Closes: Bug#1066332)

 -- Samuel Thibault <sthibault@debian.org>  Wed, 13 Mar 2024 12:39:56 +0100

eztrace-contrib (2.1-6) unstable; urgency=medium

  * Revert adding ompt support on more archs.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 15 Oct 2023 16:14:57 +0200

eztrace-contrib (2.1-5) unstable; urgency=medium

  * Add ompt support on more archs.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 15 Oct 2023 15:32:16 +0200

eztrace-contrib (2.1-4) unstable; urgency=medium

  * tests/control: Drop libpapi-dev dependency, libstarpu-dev already has it
    as appropriate.

 -- Samuel Thibault <sthibault@debian.org>  Mon, 11 Sep 2023 18:34:53 +0200

eztrace-contrib (2.1-3) unstable; urgency=medium

  * tests/control: Fix starpu tests by installing gawk.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 10 Sep 2023 17:35:32 +0200

eztrace-contrib (2.1-2) unstable; urgency=medium

  * control: Build-dep on starpu >= 1.4.1+dfsg-7 to get starpu job start/end
    traced.
  * patches/starpu-job: Drop patch, now that job start/end gets traced.

 -- Samuel Thibault <sthibault@debian.org>  Mon, 28 Aug 2023 12:10:28 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Samuel Thibault <sthibault@debian.org>
 Build-Depends: debhelper-compat (= 12),
- pkg-config,
+ pkgconf,
  cmake,
  bc, gawk,
  gfortran,
@@ -15,9 +15,9 @@
  libotf2-trace-dev, otf2-tools,
  opari2, libpomp2-dev,
  clang [amd64 arm64 i386 ppc64el riscv64], libomp-dev [amd64 arm64 i386 ppc64el riscv64],
- libstarpu-dev (>= 1.3~),
+ libstarpu-dev (>= 1.3~), libstarpu-dev (>= 1.4.1+dfsg-7) | libstarpu-dev (<< 1.4~),
  libnetcdf-dev, libpnetcdf-dev [amd64 arm64 mips64el ppc64el s390x alpha ia64 sparc64 kfreebsd-amd64 ppc64 riscv64],
- libpapi-dev [amd64 arm64 armel armhf i386 mipsel powerpc ppc64el mips64el ppc64 x32],
+ libpapi-dev [amd64 arm64 armel armhf i386 powerpc ppc64el mips64el ppc64 x32],
  libmpich-dev, mpi-default-dev, mpi-default-bin
 Rules-Requires-Root: no
 Build-Conflicts: libeztrace0

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,8 @@
 
 include /usr/share/dpkg/architecture.mk
 include /usr/share/mpi-default-dev/debian_defaults
+
+FAILED=debian/failed
 
 ifeq ($(ARCH_DEFAULT_MPI_IMPL),openmpi)
 OPENMPI=yes

=== debian/watch ===
version=3
opts=uversionmangle=s/-(rc\d*)$/~$1/ \
https://gitlab.com/eztrace/eztrace/-/tags \
/eztrace/eztrace/-/.*/eztrace-(?:eztrace-)?@ANY_VERSION@@ARCHIVE_EXT@
